#include <bits/stdc++.h>

#define EQ(a,b) (fabs(a - b) <= fabs(a + b)*EPS)

using namespace std;



int main()
{
    ios::sync_with_stdio(false);

    int V, E;
    cin >> V >> E;
    map<int, set<int>> G;
    bool isSource[V];
    bool isCollector[V];
    for(int i = 0; i < V ; i++)
    {
        isSource[i] = true;
        isCollector[i] = true;
    }

    while(true)
    {
        int start, end;
        if(! (cin >> start >> end))
            break;

        start--;
        end--;
        G[start].insert(end);
        isSource[end] = false;
        isCollector[start] = false;
    }

    int source = -1;
    int col = -1;
    for(int i = 0; i < V; i++)
    {
        if(isSource[i])
        {
            source = i;
            break;
        }
    }

    for(int i = 0; i < V; i++)
    {
        if(isCollector[i])
        {
            col = i;
            break;
        }
    }
enum STATE {UNOP, OPENED, CLOSED};
    map<int, STATE> visited;
    for(int i = 0; i < V; i++)
    {
        visited.insert({i, UNOP});
    }


    queue<int> q;
    q.push(source);
    int remove = 0;
    while(!q.empty())
    {
        auto & cur = q.front();
        if(visited[cur] != CLOSED)
        {
            visited[cur] = OPENED;

            for(auto i : G[cur])
            {
                if(visited[i] == UNOP)
                {
                    q.push(i);
                    visited[i] = OPENED;
                }
                else
                {
                    remove++;
                }

            }

        }
        visited[cur] = CLOSED;
        q.pop();
    }
    
    cout << remove << endl;
    return 0;
}